(function ($) {
  Drupal.behaviors.background_audio = {};
  Drupal.behaviors.background_audio.attach = function (context, settings) {
    if (typeof Drupal.settings.background_audio.processed != 'undefined') {
      return false;
    }
    Drupal.settings.background_audio.processed = 'processed';
    
    var div = document.createElement('div'),
    audioElement = document.createElement('audio'),
    source;
    div.className = 'background-audio';

    /* do not preload media - this prevents media loading if no autoplay */
    audioElement.setAttribute('preload', 'none');
    if (Drupal.settings.background_audio.autoplay) {
      audioElement.setAttribute('autoplay', 'autoplay');
    }
    /* is set this attribute - then the "ended" event doesn't fire after song and it repeats just the first song */
    /*if (Drupal.settings.background_audio.background_audio_loop) {
      audioElement.setAttribute('loop', 'loop');
    }*/
    audioElement.setAttribute('controls', 'controls');
    
    document.body.appendChild(div);
    div.appendChild(audioElement);
    
    $.each(Drupal.settings.background_audio.files, function(index, element) {
      source = document.createElement('source');
      source.setAttribute('src', element.url);
      source.setAttribute('title', element.filename);
      source.setAttribute('type', 'audio/mpeg');
      audioElement.appendChild(source);
    });

    var features = [];
    $.each(Drupal.settings.background_audio.controls, function(index, element) {
      features.push(index);
    });
    
    $(audioElement).mediaelementplayer({
      audioWidth: Drupal.settings.background_audio.width,
      audioHeight: Drupal.settings.background_audio.height,
      startVolume: Drupal.settings.background_audio.volume,
      loop: Drupal.settings.background_audio.loop,
      shuffle: Drupal.settings.background_audio.shuffle,
      playlist: Drupal.settings.background_audio.playlist,
      playlistposition: 'top',
      features: features
    });
  };
})(jQuery);
